#ifndef SUB_GRAPH
#define SUB_GRAPH


#include "WMtypes.h"
#include "GraphElements.h"
#include "Graph.h"


/*
 * SubGraph is a class derived from Graph (ksp_2.0) to add:
 * - a constructor to build a graph from a Topology*
 * - methods to remove an edge or a vertex from a graph
 * - a (more) correct copy constructor
 * - a (more) correct destructor
 */
class SubGraph : public Graph {
public:
  SubGraph(Topology* T);
  
  SubGraph (const SubGraph& graph);

  ~SubGraph ();
  
  void removeEdge (int u, int v);
  
  void removeVertex (int u);
  
  int getNumVertices (void) { return m_nVertexNum; }
};


#endif
