#ifndef WIMESH_PHY
#define WIMESH_PHY

#include "ns3/yans-error-rate-model.h"
#include "ns3/error-rate-model.h"
#include "ns3/core-module.h"                                                                                                  
#include "ns3/propagation-loss-model.h"
#include "ns3/wifi-mac-header.h"



using namespace ns3;

class WiMeshPropagationLossModel : public PropagationLossModel  {
  
public:
  static TypeId GetTypeId (void);
  WiMeshPropagationLossModel (){}
  
private:

  virtual double DoCalcRxPower (double txPowerDbm,
                                Ptr<MobilityModel> a,
                                Ptr<MobilityModel> b) const;

  virtual int64_t DoAssignStreams (int64_t stream);
};



class WiMeshErrorRateModel : public ErrorRateModel {
public:
  WiMeshErrorRateModel(){};
  static TypeId GetTypeId (void);
  virtual double GetChunkSuccessRate (WifiMode mode, double snr, uint32_t nbits) const;
};


#endif
